#!/usr/local/bin/perl
use CGI;
use utf8;
binmode(STDOUT, ":utf8");

# -------+-------+-------+-------+-------+------- #
#   log-chat ver2.0 (2016/2/7)
#   http://r.o0o0.jp/sc/
# -------+-------+-------+-------+-------+------- #

require './ini_utf8.cgi';


$obj = new CGI;
&get_host;

$name = $obj->param('name') if($obj->param('name'));
$color = $obj->param('color') if($obj->param('color'));
$comment = $obj->param('comment') if($obj->param('comment'));
$input_error_nm = 0;
$input_error_cm = 0;

# 入力チェック
if($name=~/[&;'\\\~\|\*\?<>^()\[\]\{\}\$\r\n\.]/){
    $input_error_nm = 1;
}
if($comment=~/[&;'\\\~\|\*\?<>^()\[\]\{\}\$\r\n\.]/){
    $input_error_cm = 1;
}
utf8::decode($name);
utf8::decode($comment);



# 分岐
if ($obj->param('mode') eq 'form' || $input_error_nm == 1 ){
  &entrance_form;
} elsif ($obj->param('mode') eq 'ent_main') {
  &entrance_bottom;
} elsif($obj->param('mode') eq 'enter') {
  if ($obj->param('name') eq "") { $name = $noname; }
  &comment_form; 
}elsif ($obj->param('mode') eq "regist" && $obj->param('comment')) {
  &regist;
} elsif ($obj->param('mode') eq "byebye") {
  &byebye;
} elsif ($obj->param('mode') eq "color_sample") {
  &colorsample;
} elsif ($obj->param('mode') eq "log_view"){
  &log_viewer;
} elsif ($obj->param('mode') eq "admin_top"){
  &admin_top;
} elsif ($obj->param('mode') eq "admin_mode"){
  &admin_mode;
}

&log_view;

# ---------------------------------------------------#
# 入口画面上側
# ---------------------------------------------------#
sub entrance_form {
	&header('body');
	print <<"EOM";
<form method="$method" action="$script" target="form" name="logchat">
<input type=hidden name=mode value="enter">

<b>おなまえ</b> <input type="text" name="name" size="20"> * 使用不可文字: &;'\"|*?~<>^()[]{}.<br />
EOM
    if ($input_error_nm == 1){
        print qq!<font color="#ee5555">ERROR: 使用不可文字が含まれます。再入力してください。</font><br />!;
    }


	print <<"EOM";

</td>　
リロード(0は手動) <select name=retime>
EOM
	#$in{'retime'} = $retime;
	foreach (@retime) {
		if ($retime eq $_) { print "<option value=$_ selected>$_ 秒</option>\n"; }
		else { print "<option value=$_>$_ 秒</option>\n"; }
	}
	print qq!</select>　文字色(<a href="./${script}?mode=color_sample" target="_blank">見本</a>)\n!;
    print qq!<select name=color>\n!;
	foreach (0 .. $#COLORS) {
		print qq!<option value="$COLORS[$_]">$IROIRO[$_]</option>\n!;
	}

	print <<"EOM";
</select><br>
<input type=submit value="入室する"></form>

<div align="right">
[<a href="$homepage" target="_top">HOME</a>]
[<a href="./$script?mode=admin_top" target="_blank">管理用</a>]
</div>
</body></html>
EOM
	exit;
}

# ---------------------------------------------------#
# 発言部分
# ---------------------------------------------------#
sub comment_form {
    my $color=$obj->param('color');
	&regist('into');

	# MSIEはフォーム長を調整
   	if ($ENV{'HTTP_USER_AGENT'} =~ /MSIE/i) { $text_width = 90; }
	else { $text_width = 50; }

	&header;

	# 以下のJavaScript(発言自動消去機能)は「ゆいちゃっと」からお借りしました
	# http://www.cup.com/yui/
	print <<"EOM";
<SCRIPT LANGUAGE="JavaScript">
<!--
function autoclear() {
 if (self.document.send) {
  if (self.document.cmode && self.document.cmode.autoclear) {
   if (self.document.cmode.autoclear.checked) {
    if (self.document.send.comment) {
      self.document.send.comment.value = "";
      self.document.send.comment.focus();
    }
   }
  }
 }
}

    function chkRegStr(str){
        var NGlist=/[&;'\\\\\"\\|\\*\\?~<>^()\\[\\]\\{\\}\.]/i;
        /* 入力された値がパターンにマッチするか調べる */
        if(str!=""){
            if(str.match(NGlist)){
                alert("入力禁止文字が含まれます");
                return false;
            }else{
                return true;
            }
        }else{
            /* 何も入力されていない場合はアラート表示 */
            alert("何も入力されていません");
            return false;
        }
    }

// -->
</SCRIPT>
</head>
$body
<form name=send method=$method action="$script" target="log" onSubmit="setTimeout(&quot;autoclear()&quot;,10)">
<input type=hidden name=mode value="regist">
<input type=hidden name=name value="$name">
<input type=hidden name=color value="$color">
<b>$nameの発言</b>：<input type=text size="$text_width" name=comment>  * 使用不可文字: &;'\"|*?~<>^()[]{}.<br>
リロード(0は手動) <select name=retime>
EOM
	foreach (@retime) {
		if ($obj->param('retime') eq $_) { print "<option value=$_ selected>$_ 秒</option>\n"; }
		else { print "<option value=$_>$_ 秒\n"; }
	}
	print <<"EOM";
</select>
<input type=submit value="発言／リロード" onclick="chkRegStr(this.form.comment.value)" /><input type=reset value="クリア"></form>
<table border="0" cellspacing="2" cellpadding="1"><tr>
<td>
  <form action="$script" method="$method" target=form>
  <input type=submit value="退室する">
  <input type=hidden name=mode value="byebye">
  <input type=hidden name=name value="$name">
  </form>
</td>
<td>
  <form action="$script" target="_blank">
  <input type=hidden name=mode value="log_view">
  <input type=submit value="過去ログ">
  </form>
</td>
<td valign=top>
  <form name="cmode">
  <input type="checkbox" name="autoclear" checked>発言自動消去
</td></form></tr></table>
</body></html>
EOM
	exit;
}


# ---------------------------------------------------#
#  記事表示  
# ---------------------------------------------------#
sub log_view {
    if ($csflag) { &color_sample; }
    if (!$obj->param('retime')) { $re = $retime; } else {$re=$obj->param('retime');}
    &header;
    if ($re != 0) {
      print qq!<meta http-equiv="refresh" content="$re; url=./$script?retime=$re">!;
      #print "<META HTTP-EQUIV=\"refresh\" CONTENT=\"$re; URL=./$script?retime=$re\">\n";
    }
    print qq!</head>\n$body\n<div align=right>!;

    # 参加者表示
    &check_member;

	print "</div><hr size=1>\n";

	if(!open(IN,"$logfile")){
      print qq!※ログがありません!;
      &foot;
    }
    while (<IN>) {
		my ($date1,$name1,$com1,$color1) = split(/<>/);
                utf8::decode($date1);
                utf8::decode($name1);
                utf8::decode($com1);
                utf8::decode($color1);
		print "<font color=\"$color1\"><b>$name1</b></font> ＞ $com1 ($date1)$sikiri\n";
	}
	close(IN);

	&foot;
}

# ---------------------------------------------------#
#  参加者のカウント
# ---------------------------------------------------#
sub check_member{
	if(!open(IN,"$memfile")){
      print "- 現在参加者はいません -";
      return;
    }

	@data = <IN>;
	close(IN);
#        utf8::decode(@data);

	$member="";
	@new=();
	foreach (@data) {
                utf8::decode($_);
		my ($time2,$name2,$color2,$host2) = split(/<>/, $_);
		push(@new,"<font color=\"$color2\">$name2</font>");
	}
    $" = ',';
    $member = qq!@new!;
    $" = ' ';

	# 参加者数を認識
	$num = @new;
	if($num){
      print "参加者($num)：$member\n";
    } else {
      print "- 現在参加者はいません -";
    }
}

# ---------------------------------------------------#
#  在室者処理  
# ---------------------------------------------------#
sub sanka {
    my $color=$color;
    my $file_flg=0;
    if(!open(INOUT,"+< $memfile")){
       open(INOUT,">$memfile");
       chmod 0666,"$memfile";
       $file_flg = 1;
    }
    flock(INOUT, 2);
    @data = <INOUT> if(!$file_flg);

    my @new=();
    my $flag=0;
    my $logout="";
    foreach (@data) {
      utf8::decode($_);
      my ($time2,$name2,$color2,$host2) = split(/<>/, $_);
      chomp($host2);
      my $tmp = $_;

      # 一定時間 ($stay) 以上発言のない者は削除
      if ($times - $stay * 60 > $time2) {
        &WriteLog("$date<>MASTER<><b>$name2</b>$out_msg<>$rep_color<>$host2\n");
        $flag=1;
        next;
      }
      if ($host2 eq $ENV{'REMOTE_ADDR'} && $name) {
         # 退室者は削除
        if ($obj->param('mode') eq "byebye") {
          $flag=1;
          next;
        }
        if ($name2 ne $name || $name2 eq $name && $obj->param('mode') eq 'enter'){
           # ホスト名が同一であれば時間と名前を更新
           &WriteLog("$date<>MASTER<><b>$name2</b>$out_msg<>$rep_color<>$host2\n");
           $name2 = $name;  $color2 = $color;
           &WriteLog("$date<>MASTER<><b>$name</b>$in_msg<>$rep_color<>$ENV{'REMOTE_ADDR'}\n") if($obj->param('mode') ne 'enter');
        }
        $flag=1;
        $tmp = qq!$times<>$name2<>$color2<>$host2\n!;
      }
    # 更新用配列 @new に追加
    push(@new,$tmp);
    }
    # 新規参加者を追加
    if (!$flag && $name) {
      push(@new,"$times<>$name<>$color<>$ENV{'REMOTE_ADDR'}\n");
      &WriteLog("$date<>MASTER<><b>$name</b>$in_msg<>$rep_color<>$ENV{'REMOTE_ADDR'}\n") if($obj->param('mode') ne 'enter');
    }

    $num = @new;
    # ファイル更新
    if($num==0){
      close(INOUT); # ロックは自動的に解除される
      unlink "$memfile";
    }else{
      seek(INOUT, 0, 0); # 書き込み場所をファイル先頭に巻き戻し～
      print INOUT @new;
      truncate(INOUT, tell(INOUT));
      close(INOUT); # ロックは自動的に解除される
    }
}

# ---------------------------------------------------#
#  ログ書込処理 
# ---------------------------------------------------#
sub regist {
    if ( $input_error_cm == 0 ){
        my $lcomment,$lname,$lcolor='';

	# 日時の取得
	$ENV{'TZ'} = "JST-9";
	$times = time;
	($sec,$min,$hour,$mday,$mon,$year) = localtime($times);
	$date = sprintf("%s\/%02d\-%02d\:%02d\:%02d", $mon+1,$mday,$hour,$min,$sec);

	# 参加者機能
	&sanka;

	# ログ形態を判断
	if ($_[0] eq 'into') {
		$lcomment = "<b>$name</b>$in_msg";
		$lname  = "MASTER";
		$lcolor = $rep_color;
	} elsif ($_[0] eq 'bye') {
                utf8::decode($name);
		$lcomment = "<b>$name</b>$out_msg";
		$lname  = "MASTER";
		$lcolor = $rep_color;
	} else {
		$lname  = $name;
		$lcolor = $color;
        $lcomment = $comment;
	}

	#ログ書き込み
        &WriteLog("$date<>$lname<>$lcomment<>$lcolor<>$ENV{'REMOTE_ADDR'}\n");
    }
}

# ---------------------------------------------------#
#  ホスト名取得  
# ---------------------------------------------------#
sub get_host {
	$host = $ENV{'REMOTE_HOST'};
	$addr = $ENV{'REMOTE_ADDR'};

	if ($host eq "" || $host eq $addr) {
		$host = gethostbyaddr(pack("C4", split(/\./, $addr)), 2) || $addr;
	}

   # 開発用設定
   $Home = 'http://r.o0o0.jp/sc/'; # ホーム
   $Ver = '2.0 (UTF8版)'; # バージョン
}

# ---------------------------------------------------#
#  退室処理 
# ---------------------------------------------------#
sub byebye {
	&header('body');
	&regist('bye');
	print <<"EOM";
<center><h3>$nameさん、ご利用ありがとうございました</h3>
[<a href="$homepage" target="_top">トップへもどる</a>]</center>
</body></html>
EOM
	exit;
}

# ---------------------------------------------------#
#  エラー処理  
# ---------------------------------------------------#
sub error {
	&header('body') if (!$head_flag);
	print "<center><hr width='70%'><h3>ERROR !</h3>\n";
	print "<font color=red><B>$_[0]</B></font>\n";
	print "<P><hr width='70%'></center>\n</body></html>\n";
	exit;
}

# ---------------------------------------------------#
#  HTMLヘッダ  
# ---------------------------------------------------#
sub header {
	$head_flag=1;
	print "Content-type: text/html\n\n";
	print <<"EOM";
<html><head>
<META HTTP-EQUIV="Content-type" CONTENT="text/html; charset=utf-8">
<STYLE TYPE="text/css">
<!-- 
body,tr,td,th {
  font-size:$b_size;
}
html{
  scrollbar-base-color:#fff;
  scrollbar-face-color:#fff;
  scrollbar-track-color:#fff;
  scrollbar-highlight-color:#444;
  scrollbar-3dlight-color:#fff;
  scrollbar-shadow-color:#444;
  scrollbar-darkshadow-color:#fff;
  scrollbar-arrow-color:#09c;
}
input,textarea {
  color: #555555;
  background-color:#ffffff;
  border: 1 solid #bbbbbb;
}
a {color: #a77;}

 -->
</STYLE>
<title>Chat-Room</title>
EOM
	if ($_[0] eq "body") { print "</head>\n$body\n"; }
}

# ---------------------------------------------------#
#  フッター表示
#  著作権を表示（削除不可）
# ---------------------------------------------------#
sub foot{
	print <<"EOM";
<center><small>
- <a href='$Home' target='_top'>log-chat ver.$Ver</a> -<br>
</small></center>\n</body></html>
EOM
	exit;

}


# ---------------------------------------------------#
# 入口画面下側
# ---------------------------------------------------#
sub entrance_bottom {
    &header;
    print qq!$body<center><br><br><br>[ !;
	# 日時の取得
	$ENV{'TZ'} = "JST-9";
	$times = time;
	($sec,$min,$hour,$mday,$mon,$year) = localtime($times);
	$date = sprintf("%s\/%02d\-%02d\:%02d\:%02d", $mon+1,$mday,$hour,$min,$sec);

    # タイムアウト確認
    &sanka;

    # 参加者表示
    &check_member;

    print qq! ]<br>
<br>※ 使い方 ※<br>
入出後は、一度リロードボタンを押してください。<br><br>
$stay分以上発言がない場合は参加者一覧から削除されます。<br>
同ホストからの入室は上書きされますので、もし窓を閉じてしまった場合は気にせず再入室してください。<br>
JavaScriptはon推奨。名前を入力しなかった場合「$noname」になります。<br>
<br>
ログの消去は、上フレームの[管理用]から行えます。<br>
<br>!;
	&foot;
}

# ---------------------------------------------------#
# ログ書き込み
# ---------------------------------------------------#
sub WriteLog{
    my ($text)=@_;

    my $file_flg=0;
    my @lines =();

    if(!(-e $logfile)){
      open(LOG,"> $logfile");
      chmod 0666,"$logfile";
      flock(LOG, 2); # 排他ロックが得られるまで永遠に待つ
    } else {
      open(LOG,"+< $logfile");
      flock(LOG, 2); # 排他ロックが得られるまで永遠に待つ
      @lines = <LOG>;
#      utf8::decode(@lines);
      while ($max <= @lines) { pop(@lines); }
    }


    # 更新処理
    unshift (@lines,$text);

    seek(LOG, 0, 0);
    print LOG @lines;
    truncate(LOG, tell(LOG));
    close(LOG);

	# バックアップ処理
	@lines = (); $file_flg=0;
	unshift (@lines,$text);

    if(!(-e $full_log)){
       open(LOG,"> $full_log");
       chmod 0666,"$full_log";
    }
	open(LOG2,">>$full_log") || &error("Can't write $full_log");
	print LOG2 @lines;
	close(LOG2);
}




# -------+-------+-------+-------+-------+------- #
#   管理モード
# -------+-------+-------+-------+-------+------- #

# ---------------------------------------------------#
# 管理画面TOP
# ---------------------------------------------------#
sub admin_top{
   &header('body');

   print qq!<font color="#c22">$admintext</font><br><br><br>! if($admintext);

   print qq!
<strong>管理画面</strong><br><br><br>
<br>
<form method="$method" action="$script" target="_top" name="logchat">
<input type=hidden name=mode value="admin_mode">
■ 動作を選んでください<br>
　<input type="radio" name="move" value="log_del"> ログ消去（取り消せません）<br>
　<input type="radio" name="move" value="log_view"> ログ閲覧<br>
<br>
■ 管理パスワード：
<input type="text" name="pwd" size="10"><br>
<br><br>
<input type=submit value="実行"></form>
<br><br><br>!;
  &foot;
}

# ---------------------------------------------------#
# 管理動作
# ---------------------------------------------------#

sub admin_mode{
  if($obj->param('pwd') ne $pwd){
    $admintext = "※ パスワードが正しくありません" 
  }
  if(!$obj->param('move')){
    $admintext .= "<br>※ 動作を選択してください" 
  }

  # ログ消去
  if($obj->param('move') eq "log_del" && $obj->param('pwd') eq $pwd){
    if(-e $logfile) {
      if((unlink "$memfile","$logfile","$full_log") == 3){
        $admintext .= "<br>※ ログを削除しました";
      } else {
        $admintext .= "<br>※ 一部のログが削除できませんでした";
      }
    }else{
      if((unlink "$logfile","$full_log") == 2){
        $admintext .= "<br>※ ログを削除しました";
      } else {
        $admintext .= "<br>※ 一部のログが削除できませんでした";
      }
    }
    &admin_top;

  } elsif($obj->param('move') eq "log_view" && $obj->param('pwd') eq $pwd){
    &log_viewer;
  }

}



# -------+-------+-------+-------+-------+------- #
#   log-chat viewer
# -------+-------+-------+-------+-------+------- #

sub log_viewer{
    # 改行コード判定
    my $br = "\x0d\x0a";
    my $agent = $ENV{'HTTP_USER_AGENT'};
    if($agent =~/Mac/i){
       $br = "\x0d";
    } elsif($agent =~ /Linux/i) {
       $br = "\x0a";
    }

	print "Content-type: text/html\n\n";
	print qq!<html><head>$br!;
    print qq!<META HTTP-EQUIV="Content-type" CONTENT="text/html; charset=utf-8">$br!;
    print qq!<STYLE TYPE="text/css">$br<\!-- $br!;
    print qq!body {$br!;
    print qq!  font-size:$b_size;$br!;
    print qq!  line-height:140%;$br!;
    print qq!  scrollbar-base-color:#fff;$br!;
    print qq!  scrollbar-face-color:#fff;$br!;
    print qq!  scrollbar-track-color:#fff;$br!;
    print qq!  scrollbar-highlight-color:#444;$br!;
    print qq!  scrollbar-3dlight-color:#fff;$br!;
    print qq!  scrollbar-shadow-color:#444;$br!;
    print qq!  scrollbar-darkshadow-color:#fff;$br!;
    print qq!  scrollbar-arrow-color:#09c;$br!;
    print qq!}$br!;
    print qq!a {color: #999;}$br!;
    print qq! -->$br</STYLE>$br!;
    print qq!<title>ChatLog</title>$br!;
    print qq!</head>$br<body bgcolor="#ffffff" text="#666666" leftmargin="80">$br!;


    if(!open(IN,"$full_log")){
       print qq!※ログがありません<br><br><br>!;
       &foot;
    }

    # 日付の取得
    my $firstdate = ''; my $n=0; my $lastdate ='';
    while (<IN>) {
      my ($date,$name,$coment,$color) = split(/<>/);
      $firstdate = $date if(!$n);
      $lastdate = $date if($date ne '');
      $n=$n+1;
    }
    print qq!<br><b><font size="+2">会話ログ</font></b> ($firstdate -> $lastdate)<br><br><br>$br!;

    # ログの書き出し
    seek(IN, 0, 0);
    while (<IN>) {
      ($date,$name,$com,$color) = split(/<>/);
      utf8::decode($date);
      utf8::decode($name);
      utf8::decode($com);
      utf8::decode($color);
      print qq!<font color=\"$color\"><b>$name</b></font> ＞ $com!;
      print qq!<font color="#aaaaaa">　($date)</font>! if($w_time);
      print qq!<br>$br!;
    }
    close(IN);

    print qq!<br><br><br><br><br>$br!
    &foot;
}






# -------+-------+-------+-------+-------+------- #
#   log-chat color_sample
# -------+-------+-------+-------+-------+------- #

sub colorsample {

	print "Content-type: text/html\n\n";
	print <<"HTML";
<html>
<head>
<META HTTP-EQUIV="Content-type" CONTENT="text/html; charset=utf-8">
<title>$title_色見本</title>
</head>
$body
<center>
<h2>色見本</h2>
HTML

	print "<table border=1>\n";
	foreach (0 .. $#COLORS) {
		print "<tr><th width=128><font color=$COLORS[$_]>$IROIRO[$_]</font></th><td bgcolor=$COLORS[$_] width=64>　</td></tr>\n";
	}
	print "</table>";
	print "</center><p>\n";

    &foot;
}



__END__

